################
## LISTING 23.1
################
word = "bird\n"                            #A
print(word)                                #B
word = word.replace("\n", "")              #C
print(word)                                #D
#A Creates a variable whose value is a string with a newline character
#B Prints the word with an extra newline
#C Replaces newline with an empty string, and assigns the result back to the same variable 
#D Prints without an extra line




################
## LISTING 23.2
################
def read_file(file):
    """                                                          #A
    file, a file object                                          #A
    Starting from the first line, it reads every 2 lines         #A
    and stores them in a tuple.                                  #A
    Starting from the second line, it reads every 2 lines        #A
    and stores them in a tuple.                                  #A
    Returns a tuple of the two tuples.                           #A
    """                                                          #A
    first_every_2 = ()                            #B
    second_every_2 = ()                           #B
    line_count = 0                                        #C
    for line in file:                                     #D
        stripped_line = line.replace("\n", "")            #E
        if line_count%2 == 0:                             #F
            first_every_2 += (stripped_line,)             #G
        elif line_count%2 == 1:                           #H
            second_every_2 += (stripped_line,)            #I
        line_count += 1                                   #J
    return (first_every_2, second_every_2)               #K
#A docstring
#B Empty tuples for names and phone numbers
#C Counter for line number
#D Loops through every line
#E Removes newline character
#F Odd-numbered lines
#G Adds to the names tuple
#H Even-numbered lines
#I Adds to the phone tuple
#J Increments line number
#K Returns a tuple of tuples


################
## LISTING 23.3
################
def sanitize(some_tuple):
    """ 
    phones, a tuple of strings
    Removes all spaces, dashes, and open/closed parentheses 
    in each string
    Returns a tuple with cleaned up string elements
    """
    clean_string = ()                      #A
    for st in some_tuple:
        st = st.replace(" ", "")           #B
        st = st.replace("-", "")           #B
        st = st.replace("(", "")           #B
        st = st.replace(")", "")           #B
        clean_string += (st,)              #C
    return clean_string                    #D
#B Replaces unnecessary characters with empty string
#A Empty tuple
#C Adds cleaned number to new tuple
#D Returns new tuple
 


################
## LISTING 23.4
################
friends_file = open('friends.txt')             #A
(names, phones) = read_file(friends_file)      #B

print(names)                                      #C
print(phones)                                     #C
clean_phones = sanitize(phones)                   #D

print(clean_phones)                               #C
friends_file.close()                              #E
#A Opens the file
#B Calls function
#C Outputs printed to the user
#D Sees whether your function worked
#E Closes the file 



################
## LISTING 23.5
################
def get_unique_area_codes():    
    """ 
    Returns a tuple of all unique area codes in phones
    """
    area_codes = ()                               #A 
    for ph in phones:                             #B
        if ph[0:3] not in area_codes:             #C
            area_codes += (ph[0:3],)              #D

    return area_codes
#A Tuple to contain unique area codes
#B Goes through every area code, variable phones is a parameter to analyze_friends
#C Checks that area code isnt there
#D Concatenates tuple of unique codes with a singleton tuple 



################
## LISTING 23.6
################
def get_states(some_areacodes):
    """
    some_areacodes, a tuple of area codes
    Returns a tuple of the states associated with those area codes
    """
    states = ()
    for ac in some_areacodes:
        if ac not in all_areacodes:              #A 
            states += ("BAD AREACODE",)
        else:
            index = all_areacodes.index(ac)       #B 
            states += (all_places[index],)        #C 
    return states
#A User gave you a bogus value, variable all_areacodes is a parameter to analyze_friends
#B Finds the position of the area code in tuple
#C Uses position to look up the state 




################
## LISTING 23.7
################
def analyze_friends(names, phones, all_areacodes, all_places):
    """
    names, a tuple of friend names
    phones, a tuple of phone number without special symbols
    all_areacodes, a tuple of area codes
    all_places, a tuple of tuples
    Prints out how many friends you have and every unique 
    state that is represented by their phone numbers.
    """

    def get_unique_area_codes():    
        """ 
        Returns a tuple of all unique area codes in phones
        """
        area_codes = ()
        for ph in phones:
            if ph[0:3] not in area_codes:            
                area_codes += (ph[0:3],)

        return area_codes

    def get_states(some_areacodes):
        """
        some_area_codes, a tuple of area codes
        Returns a tuple of the states associated with those area codes
        """
        states = ()
        for ac in some_areacodes:
            if ac not in all_areacodes:
                states += ("BAD AREACODE",)
            else:
                index = all_areacodes.index(ac)
                states += (all_places[index],)
        return states
    
    num_friends = len(names)                              #A 
    unique_area_codes = get_unique_area_codes()           #B 
    unique_states = get_states(unique_area_codes)         #C 
        
    print("You have", num_friends, "friends!")            #D 
    print("They live in", unique_states)          #E

                                                  #F
#A Number of friends
#B Keeps only unique area codes
#C Gets states corresponding
#D Prints number of friends
#E Prints the unique states
#F Nothing to return


################
## LISTING 23.8
################
friends_file = open('friends.txt')                #A
(names, phones) = read_file(friends_file)         #B
areacodes_file = open('map_areacodes_states.txt') #A
(areacodes, states) = read_file(areacodes_file)   #B

clean_phones = sanitize(phones)                           #C
analyze_friends(names, clean_phones, areacodes, states)   #D

friends_file.close()                              #E
areacodes_file.close()                            #E
#A Opens files in the same directory as the program
#B Uses the same function to read two different data sets
#C Normalizes the phone data
#D Calls the function that does most of the work
#E Closes the files
