################
## LISTING 27.1
################
legs = {}                  #A
legs["human"] = 2          #B
legs["cat"] = 4            #C
legs["snake"] = 0          #D
print(len(legs))           #E
legs["cat"] = 3            #F
print(len(legs))           #G
print(legs)                #H
#A Empty dictionary
#B Adds key human with value 2
#C Adds key cat with value 4
#D Adds key snake with value 0
#E Prints 3 because there are three entries in the dictionary
#F Changes key cat to value 3
#G Prints 3 because you modified only the entry for "cat"
#H Prints {'human': 2, 'snake': 0, 'cat': 3}




################
## LISTING 27.2
################
household = {"person":4, "cat":2, "dog":1, "fish":2}     #A
removed = household.pop("fish")                          #B
print(removed)                                           #C
#A Fills a dictionary
#B Removes entry whose key is fish and saves the value associated with the key fish in a variable
#C Prints value of removed entry




################
## LISTING 27.3
################
grades = {}                        #A
grades["Chris"] = [100, 70]        #A
grades["Angela"] = [90, 100]       #A
grades["Bruce"] = [80, 40]         #A
grades["Stacey"] = [70, 70]        #A

for student in grades.keys():      #B
    print(student)                 #B

for quizzes in grades.values():    #C
    print(sum(quizzes)/2)          #C
    
for student in grades.keys():              #D
    scores = grades[student]                      #E
    grades[student].append(sum(scores)/2)         #F
print(grades)                                     #G
#A Sets up the dictionary mapping string to a list of the two quiz scores
#B Iterates through keys and prints them
#C Iterates through values and prints their average
#D Iterates through all keys
#E Takes scores of each student and assigns them to the scores variable for average calculation in the next line
#F Takes the average of the elements and appends it to the end of the list
#G Prints {'Bruce': [80, 40, 60.0], 'Stacey': [70, 70, 70.0], 'Angela': [90, 100, 95.0], 'Chris': [100, 70, 85.0]}



################
## LISTING 27.4
################
lyrics = "Happy birthday to you Happy birthday to you Happy birthday dear Happy birthday to you"                                           #A
counts = {}                                                      #B

words = lyrics.split(" ")                                        #C
for w in words:                                                  #D
    w = w.lower()                                                #E
    if w not in counts:
        counts[w] = 1                                            #F
    else:
        counts[w] += 1                                           #G
        
print(counts)                                                    #H
#A String with song lyrics
#B Empty frequency dictionary
#C Gets a list of all words in the string by splitting the string on the space character
#D Iterates through each word in the list from the preceding line
#E Converts to lowercase
#F Word isnt in the dictionary yet, so add it as the key and set its value to 1
#G Word is already in the dictionary, so increment its count by 1
#H Prints {'happy': 4, 'to': 3, 'dear': 1, 'you': 3, 'birthday': 4}



################
## LISTING 27.5
################
def square(x):                            #A
    return x*x                            #A
    
def circle(r):                            #B
    return 3.14*r*r                       #B
    
def equilateraltriangle(s):               #C
    return (s*s)*(3**0.5)/4               #C
    
areas = {"sq": square, "ci": circle, "eqtri": equilateraltriangle}    #D

n = 2
print(areas["sq"](n))                                    #E
print(areas["ci"](n))                                    #F
print(areas["eqtri"](n))                                 #G
#A Known function to calculate area of a square
#B Known function to calculate area of a circle
#C Known function to calculate area of an equilateral triangle
#D Dictionary maps string to function
#E Calls function mapped in dictionary by key sq on n where n is 2
#F Calls function mapped in dictionary by key ci on n where n is 2
#G Calls function mapped in dictionary by key eqtri on n where n is 2
