################
## LISTING 28.1
################
def add_word(d, word, definition):            #A
    """ d, dict that maps strings to lists of strings
        word, a string
        definition, a string
        Mutates d by adding the entry word:definition
        If word is already in d, append definition to words value list
        Does not return anything
    """
    if word in d:                             #B
        d[word].append(definition)            #C
    else:                                     #D
        d[word] = [definition]                #E

words = {}                                    #F
add_word(words, 'box', 'fight')               #G
print(words)                                  #H
add_word(words, 'box', 'container')           #I
print(words)                                  #J
add_word(words, 'ox', 'animal')               #K
print(words)                                  #L
#A A function that takes in a dictionary, a string (word), and another string (definition)
#B Word in dictionary
#C Adds definition to end of keys value list
#D Word not in dictionary
#E Makes new list with one word as the keys value
#F Outside function, creates an empty dictionary
#G Calls the function with the dictionary named words as the actual parameter
#H Prints {'box': ['fight']}
#I Calls the function again to append to the value for the key box
#J Prints {'box': ['fight', 'container']}
#K Calls the function again to add another entry
#L Prints {'ox': ['animal'], 'box': ['fight', 'container']}




################
## LISTING 28.2
################
songs = {"Wannabe": 1, "Roar": 1, "Let It Be": 5, "Red Corvette": 4}     #A

for s in songs.keys():               #B
    if songs[s] == 1:                #C
        songs.pop(s)                 #D
#A songs dictionary
#B Iterates through every pair
#C If the rating value is 1
#D Removes the song with that value


################
## LISTING 28.3
################
songs = [1, 1, 5, 4]               #A

for s in songs:                    #B
    if s == 1:                     #C
        songs.pop(s)               #D
print(songs)                       #E
#A Song rating list
#B Iterates through every rating
#C If the rating value is 1
#D Removes the song with that value
#E Prints [1,5,4]


################
## LISTING 28.4
################
songs = [1, 1, 5, 4]               #A
songs_copy = songs.copy()          #B
songs = []                         #C
for s in songs_copy:               #D
    if s != 1:                     #E
        songs.append(s)            #F
print(songs)                       #G
#A Original ratings list
#B Makes a copy of the object
#C Sets original list to be empty
#D For every rating in the list
#E If the rating is one to keep
#F Adds the rating to the original list
#G Prints [5,4]
