################
## LISTING 29.1
################
def read_text(filename):
    """                                                   #A
    filename: string, name of file to read                #A
    returns: string, contains all file contents           #A
    """                                                   #A
    inFile = open(filename, 'r')                          #B
    line = inFile.read()                                  #C
    return line                                           #D

text = read_text("sonnet18.txt")                          #E
print(text)
#A Docstring
#B Python function to open the file by using the filename
#C Python function to read all contents as a string
#D Return string
#E Function call 







################
## LISTING 29.2
################
import string                                      #A

def find_words(text):
    """
    text: string
    returns: list of words from input text
    """
    text = text.replace("\n", " ")               #B
    for char in string.punctuation:              #C
        text = text.replace(char, "")            #D

    words = text.split(" ")                      #E
    return words                                 #F

words = find_words(text)                         #G
#A Brings in functions related to strings
#B Replaces newlines with a space
#C Uses preset punctuation character from string 
#D Replaces punctuation characters with the empty string
#E Makes a list of all words by using a space separator
#F Returns list of words
#G Function call



################
## LISTING 29.3
################
def frequencies(words):
    """
    words: list of words
    returns: frequency dictionary for input words
    """
    freq_dict = {}                              #A

    for word in words:                          #B
        if word in freq_dict:                   #C
            freq_dict[word] += 1                #D
        else:                                   #E
            freq_dict[word] = 1                 #F
       return freq_dict                            #G

freq_dict = frequencies(words)                  #H
#A Initially empty dictionary
#B Looks at each word in list
#C If word already in dictionary
#D Adds one to its count
#E Word not in dictionary yet
#F Adds word and sets its count to 1
#G Returns dictionary
#H Function call





################
## LISTING 29.4
################
def calculate_similarity(dict1, dict2):
    """
    dict1: frequency dictionary for one text
    dict2: frequency dictionary for another text
    returns: float, representing how similar both texts are to each other
    """
    diff = 0
    total = 0

    for word in dict1.keys():                               #A
        if word in dict2.keys():                            #B
            diff += abs(dict1[word] - dict2[word])          #C
        else:                                               #D
            diff += dict1[word]                             #E

    for word in dict2.keys():                                #F
        if word not in dict1.keys():                         #G
            diff += dict2[word]                              #H

    total = sum(dict1.values()) + sum(dict2.values())        #I
    difference = diff / total                                #J
    similar = 1.0  difference                               #K

    return round(similar, 2)                                 #L
#A Iterates over words in one dictionary
#B Word is in both dictionaries
#C Adds the difference in frequencies
#D Word doesnt appear in the other dictionary
#E Adds the entire frequency
#F Iterates over words in other dictionary
#G Counted word in both dictionaries, looks only at words not in dict1
#H Adds entire frequency
#I Total number of words in both dictionaries
#J Divides difference by total number of words
#K Subtracts difference from 1
#L Rounds to 2 decimal places and returns score between 0 and 1



################
## LISTING 29.5
################
text_1 = read_text("sonnet18.txt")
text_2 = read_text("sonnet19.txt")
words_1 = find_words(text_1)
words_2 = find_words(text_2)
freq_dict_1 = frequencies(words_1)
freq_dict_2 = frequencies(words_2) 
print(calculate_similarity(freq_dict_1, freq_dict_2))
