################
## LISTING 34.1
################
class Player(object):
    """ a player """
    def __init__(self, name):
        """ sets the name and an empty hand """
        self.hand = []                      #A
        self.name = name                    #B
    def get_name(self):                     #C
        """ Returns the name of the player """
        return self.name                    #C
#A Sets a hand to be an empty list
#B Sets the name to the string passed in when creating a Player object
#C A method to return the players name



################
## LISTING 34.2
################
class Player(object):
    """ a player """
    # methods from Listing 34.1
    def add_card_to_hand(self, card):              #A
        """ card, a string 
            Adds valid card to the player's hand """
        if card != None:
            self.hand.append(card)                  #A
    def remove_card_from_hand(self, card):          #B
        """ card, a string 
            Remove card from the player's hand """
        self.hand.remove(card)                       #B
    def hand_size(self):                             #C
        """ Returns the number of cards in player's hand """
        return len(self.hand)                        #C
#A Adding a card to the hand adds it to the list, and adds only a card with a valid number and suit.
#B Removing a card from the hand finds the card and removes it from the list.
#C The size of the hand returns the number of elements in the list.





################
## LISTING 34.3
################
class CardDeck(object):
    """ A deck of cards 2-9 of spades, hearts, diamons, clubs """
    def __init__(self):
        """ a deck of cards (strings e.g. "2C" for the 2 of clubs) 
            contains all cards possible """
        hearts = "2H,3H,4H,5H,6H,7H,8H,9H"               #A
        diamonds = "2D,3D,4D,5D,6D,7D,8D,9D"             #A
        spades = "2S,3S,4S,5S,6S,7S,8S,9S"               #A
        clubs = "2C,3C,4C,5C,6C,7C,8C,9C"                #A
        self.deck = hearts.split(',')+diamonds.split(',')  +  \     #B
                    spades.split(',')+clubs.split(',')
#A Makes a string of all possible cards in the deck
#B Splits the long string on the comma and add all cards (strings) to a list for the deck 







################
## LISTING 34.4
################
import random

class CardDeck(object):
    """ A deck of cards 2-9 of spades, hearts, diamons, clubs """
    def __init__(self):
        """ a deck of cards (strings e.g. "2C" for the 2 of clubs) 
            contains all cards possible """
        hearts = "2H,3H,4H,5H,6H,7H,8H,9H"
        diamonds = "2D,3D,4D,5D,6D,7D,8D,9D"
        spades = "2S,3S,4S,5S,6S,7S,8S,9S"
        clubs = "2C,3C,4C,5C,6C,7C,8C,9C"
        self.deck = hearts.split(',')+diamonds.split(',')        \
                    + spades.split(',')+clubs.split(',')
    def get_card(self):
        """ Returns one random card (string) and 
            returns None if there are no more cards """
        if len(self.deck) < 1:                    #A
            return None                           #A
        card = random.choice(self.deck)           #B
        self.deck.remove(card)                    #C
        return card                               #D
    def compare_cards(self, card1, card2):
        """ returns the larger card according to
            (1) the larger of the numbers or, if equal,
            (2) Spades > Hearts > Diamonds > Clubs """
        if card1[0] > card2[0]:                    #E
            return card1                           #E
        elif card1[0] < card2[0]:                  #F
            return card2                           #F
        elif card1[1] > card2[1]:                  #G
            return card1                           #G
        else:                                      #G
            return card2                           #G
#A If there are no more cards in the deck, return None.
#B Picks a random card from the deck list
#C Removes the card from the deck list
#D Returns the value of the card (string)
#5 Checks the card number value, returns the first card if its higher
#6 Checks the card number value, returns the second card if its higher
#7 When the card number value is equal, use the suit.


################
## LISTING 34.5
################
name1 = input("What's your name? Player 1: ")     #A
player1 = Player(name1)                           #B

name2 = input("What's your name? Player 2: ")
player2 = Player(name2)

deck = CardDeck()                                 #C
#A Gets user input of the player 1 name
#B Makes a new Player object


################
## LISTING 34.6
################
name1 = input("What's your name? Player 1: ")
player1 = Player(name1)
name2 = input("What's your name? Player 2: ")
player2 = Player(name2)
deck = CardDeck()

while True:
    player1_card = deck.get_card()
    player2_card = deck.get_card()
    player1.add_card_to_hand(player1_card)
    player2.add_card_to_hand(player2_card)

    if player1_card == None or player2_card == None:          #A
        print("Game Over. No more cards in deck.")
        print(name1, " has ", player1.hand_size())
        print(name2, " has ", player2.hand_size())
        print("Who won?")
        if player1.hand_size() > player2.hand_size():          #B
            print(name2, " wins!")                             #B
        elif player1.hand_size() < player2.hand_size():        #C
            print(name1, " wins!")                             #C
        else:                                                  #D
            print("A Tie!")                                    #D
        break                                                  #E
    # compare hands and add card to loser's hand
    else:                                                      #F
        print(name1, ": ", player1_card)
        print(name2, ": ", player2_card)
        if deck.compare_cards(player1_card,player2_card)==player1_card:  #G
            player2.add_card_to_hand(player1_card)                       #H
            player1.remove_card_from_hand(player1_card)                  #I
        else:
            player1.add_card_to_hand(player2_card)
            player2.remove_card_from_hand(player2_card)
#A Game over because at least one player has no more cards
#2 Checks the sizes of the hands, and player2 wins because they have fewer cards
#3 Checks the sizes of the hands, and player1 wins because they have fewer cards
#4 Players have the same number of cards, so a tie
#5 The break exits the while loop when one player wins or theres a tie.
#6 Game can continue because there are still cards to compare between hands
#7 Compares cards between players, and the returned card is the higher card
#8 Higher card belongs to player1, so add player1s card to player2s hand
#9 Higher card belongs to player1, so remove player1s card from their hand
