################
## LISTING 37.1
################
import tkinter                            #A
 
window = tkinter.Tk()                     #B
window.geometry("800x200")                #C
window.title("My first GUI")              #D
window.configure(background="grey")       #E
window.mainloop()                         #F
#A Imports the tkinter library
#B Creates a new object and binds it to a variable named window 
#C Changes the size of the window
#D Adds a title to the window 
#E Changes the background color of the window
#F Starts the program 



################
## LISTING 37.2
################
import tkinter
window = tkinter.Tk()
window.geometry("800x200")
window.title("My first GUI")
window.configure(background="grey")

red = tkinter.Button(window, text="Red", bg="red")               #A
red.pack()                                                       #B

yellow = tkinter.Button(window, text="Yellow", bg="yellow")
yellow.pack()

green = tkinter.Button(window, text="Green", bg="green")
green.pack()

textbox = tkinter.Entry(window)                           #C
textbox.pack()                                            #C

colorlabel = tkinter.Label(window, height="10", width="10")             #D
colorlabel.pack()                                                       #D

window.mainloop()
#A Creates a new button with a red background color and with the text Red on it
#B Adds the button with those properties to the window 
#C Creates and adds a box in which you can enter text
#D Creates and adds a label whose height is 10




################
## LISTING 37.3
################
import tkinter

def change_color():                               #A
    window.configure(background="white")          #B

window = tkinter.Tk()
window.geometry("800x200")
window.title("My first GUI")
window.configure(background="grey")

white = tkinter.Button(window, text="Click", command=change_color)      #C
white.pack()

window.mainloop()
#A Function representing the event to happen
#B The function changes the background color of the window.
#C Button with an associated action, by assigning the function name to the command parameter 



################
## LISTING 37.4
################
import tkinter
import time

def countdown():                                         #A
    countlabel.configure(background="white")             #B
    howlong = int(textbox.get())                         #C
    for i in range(howlong,0,-1):                        #D
        countlabel.configure(text=i)                     #E
        window.update()                                  #F
        time.sleep(1)                                    #G
    countlabel.configure(text="DONE!")                   #H

window = tkinter.Tk()
window.geometry("800x600")
window.title("My first GUI")
window.configure(background="grey")

lbl = tkinter.Label(window, text="How many seconds to count down?")     #I
lbl.pack()
textbox = tkinter.Entry(window)                                         #J
textbox.pack()
count = tkinter.Button(window, text="Countdown!", command=countdown)    #K
count.pack()
countlabel = tkinter.Label(window, height="10", width="10")             #L
countlabel.pack()

window.mainloop()
#A Event handler function
#B Changes the labels color to white
#C Gets the value from the text box and converts it to an int
#D Loops starting from the number in the text box until 0
#E Changes the text on the label to the value of the loop variable
#F Updates the window to show the updated value on the label 
#G Waits 1 second using the time library
#H Changes the text of the label to done after reaching 0
#I One label with instructions for the user 
#J Text box for the user to enter a number
#K Button to start the countdown, with the function written in the first line as the event command
#L A label on which to print the countdown
